using System;
using System.Collections.Generic;
using System.Web;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;


/// <summary>
/// Summary description for PersonWebService
/// </summary>
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class PersonWebService : System.Web.Services.WebService
{
    private string connectionName = "Provider=Microsoft.Jet.OLEDB.4.0;"
                    + "Data Source=|DataDirectory|\\PersonDatabase.mdb;"
                    + "Jet OLEDB:Database Password=;";
    public PersonWebService()
    {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }


    private PersonDTO[] GetAllePersonerWhereOrder(string where_order)
    {
        List<PersonDTO> personer = new List<PersonDTO>();
        System.Data.IDbConnection con = new System.Data.OleDb.OleDbConnection(connectionName);
        con.Open();
        System.Data.IDbCommand cmd = con.CreateCommand();
        cmd.CommandText = "SELECT Person.*, Postdistrikt.Distrikt FROM Person INNER JOIN Postdistrikt ON Person.Postnr = Postdistrikt.Postnr " + where_order;
        System.Data.IDataReader dataReader = cmd.ExecuteReader();
        while (dataReader.Read())
        {
            personer.Add(
                new PersonDTO(
                    int.Parse(dataReader["Personnr"].ToString()),
                    dataReader["Fornavn"].ToString(),
                    dataReader["Efternavn"].ToString(),
                    dataReader["Adresse"].ToString(),
                    dataReader["Tlfnr"].ToString(),
                    int.Parse(dataReader["Postnr"].ToString()),
                    dataReader["Distrikt"].ToString(),
                    int.Parse(dataReader["Version"].ToString())
                    )
                );

        }
        dataReader.Close(); /* luk foresprsel*/
        con.Close();
        return personer.ToArray();
    }

    [WebMethod]
    public PersonDTO[] GetAllePersoner()
    {
        return GetAllePersonerWhereOrder("");
    }

    [WebMethod]
    public PersonDTO[] GetAllePersonerMedNavn(string fornavn, string efternavn, bool orderEfternavnFornavn)
    {
        if (orderEfternavnFornavn)
            return GetAllePersonerWhereOrder("WHERE Fornavn like '" + fornavn + "' AND Efternavn like '" + efternavn + "' ORDER BY Efternavn, Fornavn");
        else
            return GetAllePersonerWhereOrder("WHERE Fornavn like '" + fornavn + "' AND Efternavn like '" + efternavn + "'");
    }

    [WebMethod]
    public PersonDTO[] GetAllePersonerMedPostnr(int fraPostnr, int tilPostnr, bool orderEfternavnFornavn)
    {
        if (orderEfternavnFornavn)
            return GetAllePersonerWhereOrder("WHERE Person.postnr >= " + fraPostnr + " AND  Person.postnr <= " + tilPostnr + " ORDER BY Efternavn, Fornavn");
        else
            return GetAllePersonerWhereOrder("WHERE Person.postnr >= " + fraPostnr + " AND  Person.postnr <= " + tilPostnr + " ORDER BY Person.Postnr");
    }

    [WebMethod]
    public PersonDTO GetPersonMedPersonnr(int personnr)
    {
        PersonDTO[] personer = GetAllePersonerWhereOrder("WHERE Person.personnr = " + personnr);
        if (personer.Length == 0)
            return null;
        return personer[0];
    }

    [WebMethod]
    public bool RetPersonData(PersonDTO person)
    {
        System.Data.IDbConnection con = new System.Data.OleDb.OleDbConnection(connectionName);
        con.Open();
        System.Data.IDbCommand cmd = con.CreateCommand();
        cmd.CommandText = "UPDATE Person SET Person.Fornavn='" + person.Fornavn + "' , Person.Efternavn='" + person.Efternavn + "'"
                + ", Person.Adresse='" + person.Adresse + "', Person.Tlfnr='" + person.Tlfnr + "', Person.Postnr=" + person.Postnr
                + ", Person.Version=Person.Version+1"       // Opdater Version med 1 (lock styring)
                + " WHERE Person.Personnr=" + person.Personnr 
                + " AND Person.Version=" + person.Version;  // optimistic lock - version m ikke vre opdateret
        int rettet = cmd.ExecuteNonQuery();     // antal ndret skulle gerne vre 1 - ellers er noget get galt
        con.Close();
        return rettet==1;
    }


}

