using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class WebFormStates : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (this.IsPostBack)		// state skal hentes fra tidligere
        {
        }
        else						// frste gang - state sttes
        {
            // Hent oplysningerne fra URL variabel
            if (Request.QueryString["mystate"] != null)
                this.TextBox1.Text = "URL var=" + Request.QueryString["mystate"];
            else
                //					this.TextBox1.Text = "Ingen URL variabel";
                this.TextBox1.Text = "Frste gang";
        }
    }

    protected void ButtonGemApplication_Click(object sender, EventArgs e)
    {
        // Gem oplysningerne i Application variabel
        Application["mystate"] = this.TextBox1.Text;
    }
    protected void ButtonHentApplication_Click(object sender, EventArgs e)
    {
        // Hent oplysningerne fra Application variabel
        if (Application["mystate"] != null)
            this.TextBox1.Text = Application["mystate"].ToString();
        else
            this.TextBox1.Text = "Ingen Application variabel";
    }
    protected void ButtonGemSession_Click(object sender, EventArgs e)
    {
        // Gem oplysningerne i Session variabel
        Session["mystate"] = this.TextBox1.Text;
    }
    protected void ButtonHentSession_Click(object sender, EventArgs e)
    {
        // Hent oplysningerne fra Session variabel
        if (Session["mystate"] != null)
            this.TextBox1.Text = Session["mystate"].ToString();
        else
            this.TextBox1.Text = "Ingen Session variabel";
    }
    protected void ButtonGemViewState_Click(object sender, EventArgs e)
    {
        // Gem oplysningerne i ViewState
        ViewState["mystate"] = this.TextBox1.Text;
    }
    protected void ButtonHentViewState_Click(object sender, EventArgs e)
    {
        // Hent oplysningerne fra ViewState variabel
        if (ViewState["mystate"] != null)
            this.TextBox1.Text = ViewState["mystate"].ToString();
        else
            this.TextBox1.Text = "Ingen ViewState variabel";
    }
    protected void ButtonGemCookies_Click(object sender, EventArgs e)
    {
        // Gem oplysningerne i Cookie
        HttpCookie mystateCookie;

        mystateCookie = new HttpCookie("mystate");
        mystateCookie.Value = this.TextBox1.Text;
        mystateCookie.Expires = DateTime.Now.Add(new TimeSpan(30, 0, 0, 0));
        Response.Cookies.Add(mystateCookie);
    }
    protected void ButtonHentCookies_Click(object sender, EventArgs e)
    {
        // Hent oplysningerne fra Cookie
        if (Request.Cookies["mystate"] != null)
            this.TextBox1.Text = Request.Cookies["mystate"].Value;
        else
            this.TextBox1.Text = "Ingen cookie";
    }
    protected void ButtonGemUrl_Click(object sender, EventArgs e)
    {
        string URL_adresse = "WebFormStates.aspx";
        string URL_parameter = "mystate=" + this.TextBox1.Text;		// flere separeres med &
        Response.Redirect(URL_adresse + "?" + URL_parameter);
    }
    protected void ButtonHentURL_Click(object sender, EventArgs e)
    {
        // Hent oplysningerne fra URL variabel
        if (Request.QueryString["mystate"] != null)
            this.TextBox1.Text = Request.QueryString["mystate"];
        else
            this.TextBox1.Text = "Ingen URL variabel";
    }
}
